//------------------------------------------------
// O[oϐ
//------------------------------------------------
float4x4 	g_mWorld;
float4x4 	g_mWorld_inv;
float4x4 	g_mView;
float4x4 	g_mProj;
float4		g_color0;
float4		g_color1;
float4		g_light_dir;
texture		g_texture;

texture 	g_shadowbuf;
float4		g_offset;
float4x4	g_vlp;


//------------------------------------------------
// eNX`Tv
//------------------------------------------------
sampler TextureSampler = 
sampler_state
{
    Texture = <g_texture>;
	MipFilter = NONE;
    MinFilter = LINEAR;
    MagFilter = LINEAR;

	AddressU =Clamp;
	AddressV =Clamp;
};	


sampler ShadowBufSampler = 
sampler_state
{
    Texture = <g_shadowbuf>;
    MipFilter = NONE;
    MinFilter = POINT;
    MagFilter = POINT;
	AddressU = Clamp;
	AddressV = Clamp;
};

//--------------------------------------------------------------------------------------
// Vertex shader
//--------------------------------------------------------------------------------------
void BasicShadowBufVS( 	float4 in_pos : POSITION,
						out float4 out_pos : POSITION,
						out float4 out_depth : TEXCOORD0)
{	
	// Wϊ
	out_pos = mul(in_pos, g_vlp);

	// ʒȕo
	out_depth  = out_pos;
}


//--------------------------------------------------------------------------------------
// Pixel shader
//--------------------------------------------------------------------------------------
void BasicShadowBufPS(	float4 in_depth : TEXCOORD0,
						out float4 color : COLOR)
{
	// sNZ̐[xvZďo
	color  = in_depth.z / in_depth.w;
}

//------------------------------------------------
// _VF[_
//------------------------------------------------
void BasicVS( 	float3 in_pos : POSITION,
				float3 in_normal : NORMAL,
				float2 in_tex : TEXCOORD0,
 				out float4 out_pos : POSITION,
 				out float4 out_color :COLOR0,
 				out float2 out_tex : TEXCOORD0,
 				out float4 out_pos_light : TEXCOORD1)
{
	// Wϊ
	float4 world_pos;
	world_pos = mul(float4(in_pos, 1.0f), g_world);
	out_pos = mul(world_pos, g_view);
	out_pos = mul(out_pos, g_proj);

	// eNX`W
	out_tex = in_tex;
	
	// _Ƃ̐F̌vZ
	float4 local_light;
	local_light =  normalize( mul(g_light_dir, g_world_inv));
	out_color = saturate(g_color0 + g_color1 * max(0, dot(local_light, in_normal)));
	
	// ݂_̈ʒǔvZ
	out_pos_light =  mul(world_pos, g_vlp);
}

//------------------------------------------------
// sNZVF[_
//------------------------------------------------
void BasicPS( float4 in_color : COLOR0,
 			  float2 in_tex : TEXCOORD0,
 			  float4 in_pos_light : TEXCOORD1,
			  out float4 out_color : COLOR0,
			  uniform bool b_tex)
{
	// VhE}bvl̎擾
	float2 shadow_uv = 0.5 * in_pos_light.xy /in_pos_light.w + float2(0.5, 0.5);
	shadow_uv.y = 1.0f - shadow_uv.y;
	shadow_uv .x = shadow_uv.x + g_offset.x;
	shadow_uv .y = shadow_uv.y + g_offset.y;
	float shadow_val =  tex2D(ShadowBufSampler, shadow_uv).r;

	if(b_tex){
		out_color = in_color * tex2D(TextureSampler,in_tex);
	}
	else{
		out_color = in_color;
	}

	// 璸_܂ł̋vZ
	float depth = in_pos_light.z / in_pos_light.w;
	
	// VhE}bv̐[x̒lƔr
	if( depth - shadow_val> 0.00065f){
		out_color = out_color*0.5; // eɂȂĂ
	}
	
}

//------------------------------------------------
// eNjbN錾
//------------------------------------------------
technique CreateShadowMap
{
    pass P0
    {
        VertexShader = compile vs_3_0 BasicShadowBufVS();
        PixelShader  = compile ps_3_0 BasicShadowBufPS();
	}
}

technique ShadowRender
{
    pass P0
    {
        vertexShader = compile vs_3_0 BasicVS();
        pixelShader  = compile ps_3_0 BasicPS(true);
        
	}

}
